
#include "ht1632c.h" //pour l'affichage des dessins et des textes  sur la matrice a leds
#include "pitches.h" //pour la musique

//pins de la matrice a leds
#define DATA_PIN 7
#define CLK_PIN 4
#define WRCLK_PIN 6
#define CS_PIN 5

//instanciation de la matrice
ht1632c matrix = ht1632c(&PORTD, DATA_PIN, WRCLK_PIN, CLK_PIN, CS_PIN, GEOM_32x16, 1);

const int ledPin = 13; // pin de la led de controle
int incomingByte;      // message recu
int previousByte;      // stocke l'ancienne valeur recue
char* texte="";        // texte a afficher sur la matrice

/*
// notes de la melody complete de star wars:
int melody0[] = {
  NOTE_G3, NOTE_G3,NOTE_C3, NOTE_A3,
  NOTE_FS3,NOTE_G3,NOTE_E3,NOTE_C3,
  NOTE_B3,NOTE_A3,NOTE_G3,NOTE_E3,
  NOTE_C4,NOTE_B3,NOTE_A3,NOTE_F3,
  NOTE_D3,NOTE_F3,NOTE_E3,NOTE_F3,NOTE_E3};
// note durations: 4 = quarter note, 8 = eighth note, etc.:
*/
float noteDurations[] = {
  2,1,2,2,0.5,2,4,1,4,0.5,2,2,1,4,2,4,1,2,8,8,0.25}; //duree de chaque note


//chaque tableau de notes correspond a une partie de la melodie  
int melody1[]= {NOTE_G3, NOTE_G3,NOTE_C3, NOTE_A3}; 
int melody2[]= {NOTE_FS3,NOTE_G3,NOTE_E3,NOTE_C3};
int melody3[]= {NOTE_B3,NOTE_A3,NOTE_G3,NOTE_E3};
int melody4[]= {NOTE_C4,NOTE_B3,NOTE_A3,NOTE_F3};
int melody5[]= {NOTE_D3,NOTE_F3,NOTE_E3,NOTE_F3,NOTE_E3};

void playmelody(int* melo, int lg){        //permet de jouer une melodie, prend en parametre le tableau de notes et sa longueur
  //iterate over the notes of the melody:
  for (int thisNote = 0; thisNote < lg; thisNote++) {
    // to calculate the note duration, take one second 
    // divided by the note type.
    //e.g. quarter note = 1000 / 4, eighth note = 1000/8, etc.
    int noteDuration = 1000/noteDurations[thisNote];
    tone(8, melo[thisNote],noteDuration);

    // to distinguish the notes, set a minimum time between them.
    // the note's duration + 30% seems to work well:
    int pauseBetweenNotes = noteDuration * 1.30;
    delay(pauseBetweenNotes);
    // stop the tone playing:
    noTone(8);
  }
}

void yoda(uint8_t c){ //gere le dessin de maitre et yoda 
  matrix.plot(1, 1, c);
  matrix.plot(2, 1, c);
  matrix.plot(3, 2, c);
  matrix.plot(4, 2, c);
  matrix.plot(5, 2, c);
  matrix.plot(6, 1, c);
  matrix.plot(7, 1, c);
  
  matrix.plot(2, 2, c);
  matrix.plot(6, 2, c);
  
  matrix.plot(3, 3, c);
  //matrix.plot(4, 3, c);
  matrix.plot(5, 3, c);
  matrix.plot(3, 4, c);
  //matrix.plot(4, 4, c);
  matrix.plot(5, 4, c);
  matrix.plot(4, 5, c);
  
  matrix.plot(1, 7, c);
  matrix.plot(2, 6, c);
  matrix.plot(3, 6, c);
  matrix.plot(4, 6, c);
  matrix.plot(5, 6, c);
  matrix.plot(6, 6, c);
  matrix.plot(7, 7, c);
  
  matrix.plot(2, 7, c);
  matrix.plot(3, 7, c);
  matrix.plot(4, 7, c);
  matrix.plot(5, 7, c);
  matrix.plot(6, 7, c);
  
}

void bulle(uint8_t c){
  matrix.plot(8, 4, c);
  matrix.plot(9, 3, c);
  matrix.plot(10,3, c);
  matrix.plot(11, 2, c);
  matrix.plot(12, 2, c);
  matrix.plot(13, 1, c);
  matrix.plot(14, 1, c);
  matrix.plot(15, 1, c);
  
  matrix.plot(26, 1, c);
  matrix.plot(27, 1, c);
  matrix.plot(28, 2, c);
  
  matrix.plot(30, 10, c);
  matrix.plot(29, 11, c);
  matrix.plot(28, 11, c);
  matrix.plot(28, 12, c);
  matrix.plot(27, 13, c);
  matrix.plot(26, 13, c);
  
  //matrix.plot(26, 11, c);
  matrix.plot(26, 12, c);
  matrix.plot(25, 13, c);
  //matrix.plot(24, 13, c);
 
 matrix.plot(27, 3, c);
 matrix.plot(28, 3, c);
 matrix.plot(29, 3, c);
 matrix.plot(30, 4, c);
 matrix.plot(30, 5, c);
 matrix.plot(30, 6, c);
 matrix.plot(30, 7, c);
 matrix.plot(30, 8, c);
 matrix.plot(30, 9, c);
 
 matrix.plot(8, 5, c);
 matrix.plot(8, 6, c);
 matrix.plot(8, 7, c);
 matrix.plot(8, 8, c);
 matrix.plot(8, 9, c);
 
 matrix.plot(25, 14, c);
 matrix.plot(24, 14, c);
 matrix.plot(22, 13, c);
 matrix.plot(21, 14, c);
 
 matrix.plot(15, 14, c);
 matrix.plot(14, 14, c);
 matrix.plot(13, 13, c);
 matrix.plot(13, 12, c);
 
 matrix.plot(12, 13, c);
 matrix.plot(11, 13, c);
 matrix.plot(13, 12, c);
 matrix.plot(10, 13, c);
 matrix.plot(9, 12, c);
 
 matrix.plot(7, 9, c);
 matrix.plot(6, 9, c);
 matrix.plot(5, 9, c);
 matrix.plot(4, 9, c);
 
 matrix.plot(5, 10, c);
 matrix.plot(6, 11, c);
 matrix.plot(7, 11, c);
 matrix.plot(8, 11, c);
  
}

void affichage(){  // gere le dessin de la bulle our le texte
  matrix.rect(0, 0, 31, 15, RED);
  //matrix.line(16, 14, 20, 14, ORANGE);
  //matrix.line(16, 1, 25, 1, ORANGE);
  yoda(GREEN);
  bulle(ORANGE);
}


void setup() {
  // initialize serial communication:
  Serial.begin(9600);
  // initialize the LED pin as an output:
  pinMode(ledPin, OUTPUT);
  
  matrix.clear();
  matrix.setfont(2);
  //matrix.line(2, 2, 2, 10, ORANGE);
  matrix.pwm(15);
  affichage();

  matrix.sendframe();
}

void loop() {
  // see if there's incoming serial data:
  if (Serial.available() > 0) {
  // read the oldest byte in the serial buffer:
    previousByte=incomingByte = Serial.read();
    //suivant le caractere recu:
    switch(incomingByte){
    
      case 'A':
        //musique
        playmelody(melody1, 4);
        //mise a jour de l'ecran
        matrix.clear();
        affichage();
        
        texte="Yoda";
        //affichage du texte
        for(int j=0; j<4; j++){
            matrix.putchar(10 + 4*j,4,texte[j],GREEN);
          }
          
        matrix.sendframe();
        previousByte = incomingByte;
        break;
        
      case 'B':
        playmelody(melody2, 4);
        matrix.clear();
        affichage();
        texte="Jedi";
        for(int j=0; j<4; j++){
            matrix.putchar(10 + 4*j,4,texte[j],GREEN);
          }
        matrix.sendframe();
        previousByte = incomingByte;
        break;
        
     case 'C':
        playmelody(melody3, 4);
        matrix.clear();
        affichage();
        texte="Vador";
        for(int j=0; j<5; j++){
            matrix.putchar(10 + 4*j,4,texte[j],GREEN);
          }
        matrix.sendframe();
        previousByte = incomingByte;
        break;
        
     case 'D':
        playmelody(melody4, 4);
        matrix.clear();
        affichage();
        texte="Sage";
        for(int j=0; j<4; j++){
            matrix.putchar(10 + 4*j,4,texte[j],GREEN);
          }
        matrix.sendframe();
        previousByte = incomingByte;
        break;
        
    case 'E':
        playmelody(melody5, 5);
        matrix.clear();
        affichage();
        texte="Force";
        for(int j=0; j<5; j++){
            matrix.putchar(10 + 4*j,4,texte[j],GREEN);
          }
        matrix.sendframe();
        previousByte = incomingByte;
        break;       
    }

  }
}


